

#define LENGTH 100

int vec[LENGTH];

int max;


/*@ requires 0 < size && \valid_range(u,0,size-1);
  @ ensures 0 <= \result < size &&
  @        (\forall int a; 0 <= a < size ==> u[a] <= u[\result]);
  @*/
int maxarray(int u[], int size) {
  int i = 1;
  max = 0;
  
  /*@ loop invariant 
    @    0 <= max < i <= size && 
    @    (\forall int a; 0 <= a < i ==> u[a] <= u[max]);
    @ loop variant 
    @    size-i;
    @*/
  while (i < size) {
    if (u[i] > u[max]) { max = i; }
    i++;
  }
  return max;
}





// Testar com e sem a funo main...
// N.B. pr-condio gerada no default behavior de main, e no em safety ("user call")

void main() {
  maxarray(vec, 50);
}

