
#define LENGTH 100

int vec[LENGTH];

int max;

/*@ 
  @ ensures 0 <= max < LENGTH &&
  @        (\forall int a; 0 <= a < LENGTH ==> vec[a] <= vec[max]);
  @*/
void maxarray() {
  int i = 1;
  max = 0;
  
  /*@ loop invariant 
    @    1 <= i <= LENGTH && 0 <= max < i && 
    @    (\forall int a; 0 <= a < i ==> vec[a] <= vec[max]);
    @ loop variant 
    @    LENGTH-i;
    @*/
  while (i < LENGTH) {
    if (vec[i] > vec[max]) { max = i; }
    i = i +1;
  }
}



