
#define LENGTH 100

int vec[LENGTH];

int max, size;



/*@ requires 0 < size <= LENGTH;
  @ ensures 0 <= max < size &&
  @        (\forall int a; 0 <= a < size ==> vec[a] <= vec[max]);
  @*/
void maxarray() {
  int i = 1;
  max = 0;
  
  /*@ loop invariant 
    @    0 <= max < i <= size && 
    @    (\forall int a; 0 <= a < i ==> vec[a] <= vec[max]);
    @ loop variant 
    @    size-i;
    @*/
  while (i < size) {
    if (vec[i] > vec[max]) { max = i; }
    i = i +1;
  }
}





// Testar com e sem a funo main e com size = 150...

void main() {
  size = 50;

  maxarray();
}

