


int max, size;

/*@ requires 0 < size && \valid_range(u,0,size-1);
  @ ensures 0 <= max < size &&
  @        (\forall int a; 0 <= a < size ==> u[a] <= u[max]);
  @*/
void maxarray(int u[]) {
  int i = 1;
  max = 0;
  
  /*@ loop invariant 
    @    0 <= max < i <= size && 
    @    (\forall int a; 0 <= a < i ==> u[a] <= u[max]);
    @ loop variant 
    @    size-i;
    @*/
  while (i < size) {
    if (u[i] > u[max]) { max = i; }
    i = i +1;
  }
}






